"""reads a bunch of rss feeds"""

import feedparser, urllib2, sys, threading, re, os
#import NewsItem # should not be needed anymore
from Feedisto.NewsItem import NewsItem

DEBUG = False
WARNING = True

class FeedCatcher(threading.Thread):
	def __init__(self, url, config):
		threading.Thread.__init__(self)
		self.url = url.strip()
		self.finished = False
		self.bunch = []
		self.handlers = []
		if config.http_proxy:
			self.handlers.append( urllib2.ProxyHandler({'http':config.http_proxy}) )
		self.start() # run automatically
	def run(self):
		# fill self.bunch
		f = feedparser.parse(self.url, self.handlers)
		if WARNING and len(f.entries) == 0:
			print "warning: No entries from", self.url
		for item in f.entries:
			message = NewsItem(item.title, self.url)
			message.set_expose(item.get('summary', u''))
			if item.has_key('modified'):
				message.set_date(item.get('modified', u''))
			elif item.has_key('created'):
				message.set_date(item.created)
			message.set_link(item.link)
			message.set_encoding(f.encoding)
			# feeds can have multiple <content> elements
			for text in item.get('content', []):
				message.set_text(text.value)
			self.bunch.append(message)
		self.finished = True
		if DEBUG:
			print "parsed feed:", self.url
		return

class main:
	def __init__(self, config):
		self.types = ['input']
		self.name = "rss_input"
		self.config = config
		self.feeds_file = os.path.expanduser(self.config.rss_feeds)
		self.feeds = []
		if not os.path.exists(self.feeds_file):
			fh = open(self.feeds_file, 'w')
			fh.close()
		for feed in open(self.feeds_file):
			self.add_feed(feed)
	def add_feed(self, url):
		if url.strip()[0] == "#":
			return
		self.feeds.append(url)
	def get(self):
		"""if 'input' in self.types: i need this method"""
		bunch = []
		dogs = [] # the feed retrievers
		for url in self.feeds:
			dogs.append( FeedCatcher(url, self.config) )
		if DEBUG:
			print len(dogs), "doggies are running now"
		active_threads = True
		while len(dogs) > 0:
			active_threads = False
			for doggy in dogs:
				if doggy.finished:
					for item in doggy.bunch:
						bunch.append(item)
					dogs.remove(doggy)
				else:
					active_threads = True
		return bunch
